#!/bin/sh
CATALINA_HOME=/usr/share/tomcat
JAVA_HOME=/usr/lib/jvm/java-1.7.0-openjdk
KS=/keystore.p12
CRT=$WEBDIR/server.crt

chsh -s /bin/sh tomcat

cp /root/bcprov-ext-jdk15on-1.46.jar $JAVA_HOME/jre/lib/ext
sed -i 's/sun.security.smartcardio.SunPCSC/org.bouncycastle.jce.provider.BouncyCastleProvider/' $JAVA_HOME/jre/lib/security/java.security

sed -i '/<Service name=.Catalina.>/a \
         <Connector port="8443" protocol="org.apache.coyote.http11.Http11Protocol"\
               maxThreads="5" SSLEnabled="true" scheme="https" secure="true"\
               keystoreFile="'${KS}'" keystoreType="PKCS12"\
	       clientAuth="false" sslProtocol="TLS" />' $CATALINA_HOME/conf/server.xml

sed -i "s/@CERT@/$(basename $CRT)/" $WEBDIR/index.jsp

openssl req -new -x509 -key /$PRIVKEY -subj "/CN=ICSC Qualifiers Server" -days 45 -out $CRT
openssl pkcs12 -export -inkey /$PRIVKEY -in $CRT -name tomcat -out $KS -password pass:changeit

FLAGFILE="IS THE FLAG"
openssl x509 -in $CRT -noout -pubkey > /tmp/pub
openssl pkeyutl -derive -inkey /$PRIVKEY -peerkey /tmp/pub -out "$FLAGFILE"
sha1sum "$FLAGFILE" >&2

chown tomcat $KS
chmod 400 $KS

rm -f "$FLAGFILE" /$PRIVKEY /tmp/pub /root/java-*.rpm /root/bcprov-*

